<!DOCTYPE HTML>
<!--
	Solid State by HTML5 UP
	html5up.net | @ajlkn
	Free for personal and commercial use under the CCA 3.0 license (html5up.net/license)
-->
<html>
	<head>
		<title>HEXAPP | PIDZERO</title>
		<meta charset="utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1" />
		<!--[if lte IE 8]><script src="assets/js/ie/html5shiv.js"></script><![endif]-->
		<link rel="stylesheet" href="assets/css/main.css" />
        <link rel="stylesheet" href="assets/css/page-override.css" />
        <link rel="stylesheet" href="assets/css/prism.css">
        <script src="assets/js/prism.js"></script>
        <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.0.13/css/all.css" integrity="sha384-DNOHZ68U8hZfKXOrtjWvjxusGo9WQnrNx2sqG0tfsghAvtVlRW3tvkXWZh58N9jp" crossorigin="anonymous">
		<!--[if lte IE 9]><link rel="stylesheet" href="assets/css/ie9.css" /><![endif]-->
		<!--[if lte IE 8]><link rel="stylesheet" href="assets/css/ie8.css" /><![endif]-->
	</head>
	<body>

		<!-- Page Wrapper -->
			<div id="page-wrapper">
                    <div id="bg-div">
                        <img src="/images/gif/pz_480.gif" id="bg"/>
                    </div>

				<!-- Header -->
					<header id="header">
						<h1><a href="index.html"><img src="images/logo.png" class="hxplogo-small"/></a></h1>
						<nav>
							<a href="#menu">Menu</a>
						</nav>
					</header>

				<!-- Menu -->
					<nav id="menu">
						<div class="inner">
							<h2>Menu</h2>
							<ul class="links">
								<li><a href="index.html">Home</a></li>
								<li><a href="pidzero.html">Pidzero</a></li>
                                <li><a href="about.html">About Hexapp</a></li>
							</ul>
							<a href="#" class="close">Close</a>
						</div>
					</nav>

				<!-- Wrapper -->
					<section id="wrapper">
						<header>
							<div class="inner">
								<h2>PIDZERO</h2>
								<p>lightweight container-native process manager</p>
							</div>
						</header>

						<!-- Content -->
							<div class="wrapper">
								<div class="inner">

									<h3 class="major">CONTAINERS ARE HARD</h3>
									<p>Well, containers themselves are pretty easy, its <i>operationalizing</i> them that is hard. Its not enough just to run your app in a container anymore, you need log shipping, service discovery, monitoring, and a host of other services too, but Docker (and LXC) is designed to only run a single process in each container.</p>
                                    <p>To get around this, some devops engineers use tools like supervisord or runit (or, god-forbid, they install systemd in a container), but these are large (supervisord) and unnecessarily complicated (runit). Lots of other engineers use simple shells scripts to do what they need, but when was the last time you trusted a shell script to do anything mission critical? Both of these tools were designed for full OSes, not minimal containers. They're large, their folder structures are sprawling, and it takes an expert just to get them to work correctly.</p>

									<h3 class="major">PIDZERO</h3>
									<p>We recognize that today's problems need new answers, and our answer for this problem is <b>PIDZERO</b>. <b>PIDZERO</b> is different. Its designed for containers from the ground up, simple in its implementation, and easy to learn.</p>

                                    <h3 class="major">USING PIDZERO</h3>
                                    <p>Using <b>PIDZERO</b> is easy. If you know JSON, you can deploy <b>PIDZERO</b>.</p>
                                    <h4>Process configration is stored in <i>daemons.json</i></h4>
                                    <pre><code class="language-json">
                                        [
                                            {
                                                "name": "test",
                                                "command": "sleep 100",
                                                "comment": "this is a test daemon definition for the purpose of documentation",
                                                "vital": true,
                                                "environment": [
                                                    "MY_CUSTOM_VARIABLE=mycustomvalue"
                                                ]
                                            }
                                        ]
                                    </code></pre>
                                    <ul>
                                        <li><b>NAME</b> => a name for your daemon</li>
                                        <li><b>COMMAND</b> => command to run as the daemon executable</li>
                                        <li><b>COMMENT</b> => a human-readable comment for reference</li>
                                        <li><b>VITAL</b> => mark the daemon as "vital", causing <b>PIDZERO</b> to exit if the daemon exists</li>
                                        <li><b>ENVIRONMENT</b> => environment variables to append to the command</li>
                                    </ul>

                                    <h4>START PIDZERO</h4>
                                    <p>
                                        To start <b>PIDZERO</b>, simply invoke it from the command line or as a container entrypoint.
                                    </p>
                                    <pre>
                                        <code class="language-javascript">
                                            $> /etc/pidzero/pidzero
                                        </code>
                                    </pre>

                                    <p>For full documentation, please see our <a href="https://gitlab.com/hexapp.net/pidzero" target="_blank">Gitlab <i class="fab fa-gitlab"></i> repo for <b>PIDZERO</b></a></p>

                                    <h2 class="major">Get PIDZERO</h2>
                                    <h4>Pre-Compiled Binary</h4>
                                    <ul>
                                        <li>Coming soon</li>
                                    </ul>
                                    <h4>Docker Images</h4>
                                    <ul>
                                        <li>Coming soon</li>
                                    </ul>
                                    <h4>Compile from Source</h4>
                                    <ul>
                                        <li>Clone the repo at <span class="fab fa-gitlab"></span><a href="https://gitlab.com/hexapp.net/pidzero"> gitlab.com/hexapp.net/pidzero</a></li>
                                        <li>Install <a href="https://haxe.org" target="_blank"><img src="https://haxe.org/img/branding/haxe-logo-outline-white.png" style="width:20px;" /> Haxe</a> and a C++ compiler (GNU C++, etc.)</li>
                                        <li>Run <b>make compile</b>, the binary and configs will be in <b>[clonedir]/dist/</b></li>
                                    </ul>

                                    <h2 class="major">Roadmap</h2>
                                    <ul>
                                        <li>We would like to implement a REST API for <b>PIDZERO</b> so its status is queryable from Docker</li>
                                        <li>We would also like to implement a TCP monitor for compaibility with other healthchecks</li>
                                        <li>Eventually we will make other log formats available</li>
                                    </ul>
								</div>
							</div>

					</section>

                    <!-- Footer -->
    					<section id="footer">
    						<div class="inner">
    							<h2 class="major">Get in touch</h2>
    							<p>Got any questions, comments, concerts, ideas, or feature requests? Use the contact form below and get in touch!</p>
    							<form method="post" action="https://formspree.io/social@hexapp.net">
    								<div class="field">
    									<label for="name">Name</label>
    									<input type="text" name="name" id="name" />
    								</div>
    								<div class="field">
    									<label for="email">Email</label>
    									<input type="email" name="email" id="email" />
    								</div>
    								<div class="field">
    									<label for="message">Message</label>
    									<textarea name="message" id="message" rows="4"></textarea>
    								</div>
    								<ul class="actions">
    									<li><input type="submit" value="Send Message" /></li>
    								</ul>
    							</form>
    							<ul class="contact">
    								<li class="fa-home">Washington, DC</li>
    								<li class="fa-twitter"><a href="https://twitter.com/hexappusa" target="_blank">@HexappUSA</a></li>
    								<li class="fa-gitlab"><a href="https://gitlab.com/hexapp.net" target="_blank">gitlab.com/hexapp.net</a></li>
    							</ul>
    							<ul class="copyright">
    								<li>&copy; 2018 HEXAPP | All rights reserved.</li>
    							</ul>
    						</div>
    					</section>

			</div>

		<!-- Scripts -->
			<script src="assets/js/skel.min.js"></script>
			<script src="assets/js/jquery.min.js"></script>
			<script src="assets/js/jquery.scrollex.min.js"></script>
			<script src="assets/js/util.js"></script>
			<!--[if lte IE 8]><script src="assets/js/ie/respond.min.js"></script><![endif]-->
			<script src="assets/js/main.js"></script>

	</body>
</html>
